<template>
  <div>
    <div class="deposit-page">
      <div class="wrapper-content">
        <div class="left-content">
          <div class="title-page">
            {{ $t('deposit.header') }}
          </div>

          <div class="selected-coin-msg"><p class="title">{{ $t('deposit.title') }}</p></div>

          <div class="list-coin">
            <div class="coin-item" v-for="(coin, index) in listCoin" @click="selectCoin(index)" :class="{ 'active': isCurrentCoin(coin) }">
              <div class="coin-infor">
                <img :src="coin.srcImg" :alt="coin.fullname" class="coin__image">
                  <span class="coin__name">{{ coin.name }}</span>
                  <span class="coin__fullname"> - {{ coin.fullname }}</span>
              </div>
            </div>
          </div>

          <template v-if="currentWallet">
            <div class="balance">
              <p class="balance__text">{{ $t('deposit.balance') }}</p>
              <p class="balance__value">{{ currentWallet.balance | formatCurrencyAmount(currentWallet.currency, '0') }} {{ currentWallet.currency.toUpperCase() }}</p>
            </div>

            <div class="content-box">
              <p class="title">
                {{ $t('deposit.address', {currency: currentWallet.currency.toUpperCase()}) }}
              </p>
              <p class="address">
                {{ currentWallet.address }}
              </p>
              <div class="group-btn">
                <p class="show-qr-btn" @click="showQrModal">
                  <span class="iconmo-QRcode"></span>
                  <span class="btn__text">{{ $t('deposit.btn.show_qr') }}</span>
                </p>

                <button class="copy-btn"
                    v-clipboard:copy="currentWallet.address"
                    v-tooltip="{ content: 'Copied', trigger: 'focus', autoHide: true, delay: { hide: 1000 } }">
                  <span class="iconmo-copy"></span>
                  <span class="btn__text">{{ $t('deposit.btn.copy') }}</span>
                </button>
              </div>
            </div>

            <div class="text-box">
              <div class="important">
                <p class="title">
                  {{$t('deposit.important.title')}}
                </p>

                <p class="description">
                  {{ $t('deposit.important.description', {currency: currentWallet.currency.toUpperCase()}) }}
                </p>
              </div>

              <div class="note">
                <p class="title">
                  {{ $t('deposit.note.title') }}
                </p>

                <ul class="note__list">
                  <li class="item">
                    {{ $t('deposit.note.description1', {confirmation: $options.filters.expectedConfirmation(currentCoin)}) }}
                  </li>
                  <li class="item">
                    {{ $t('deposit.note.description2') }}
                    <router-link to='/wallet/transactions'><span class='link'>{{$t('deposit.note.history_page')}}</span></router-link>
                  </li>
                  <li class="item">
                    {{
                      $t('deposit.note.description3', {
                        amount: $options.filters.minDeposit(currentCoin),
                        currency: $options.filters.uppercase(currentCoin),
                      })
                    }}
                  </li>
                </ul>
              </div>
            </div>
          </template>
        </div>
        <div class="right-content">
          <div class="deposit-table">
            <div class="thead">
              <div class="td th1">{{ $t('deposit.history.title') }}</div>
              <div class="td th2"></div>
              <div class="td th3"></div>
              <div class="td th4"
                v-tooltip.bottom="{
                  content: $t('deposit.history.tooltip'),
                  trigger: 'hover',
                  classes: 'deposit-question-tooltip',
                }"
              >{{$t('deposit.history.note')}}
                <span class="iconmo-question">
                </span>
              </div>
              <div class="td th5" @click="$router.push('wallet/transactions')">{{$t('deposit.history.view_all')}}</div>
            </div>

            <template v-if="transactions.length > 0">
              <div class="tbody">
                <transaction-information v-for="(transaction, index) in transactions" :transaction="transaction" :key="index"/>
              </div>
            </template>
            <template v-else>
              <div class="not-found">
                <span class="iconmo-not-found not-found__icon"></span>
                <span class="not-found__text">{{$t('deposit.not_found_text')}}</span>
              </div>
            </template>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
  import { mapState, mapActions } from 'vuex';
  import TransactionInformation from '../components/Deposit/TransactionInformation';
  import rf from '../../common/requests/RequestFactory';
  import QrModal from '../components/Modal/QrModal';

  export default {
    name: 'Deposit',
    components: {
      QrModal,
      TransactionInformation,
    },
    data() {
      return {
        currentCoin: '',
        transactions: [],
        listCoin: [
          {
            srcImg: '/images/icon/balanceImg/heta-btc-icon.png',
            name: 'btc',
            fullname: 'Bitcoin',
          },
          {
            srcImg: '/images/icon/balanceImg/heta-usdt-icon.png',
            name: 'usdt',
            fullname: 'TetherUS',
          },
          {
            srcImg: '/images/icon/balanceImg/heta-eth-icon.png',
            name: 'eth',
            fullname: 'Ethereum',
          },
        ],
        modalData: {},
      }
    },
    computed: {
      ...mapState(['wallets', 'user']),
      currentWallet() {
        if (!this.wallets || !this.currentCoin) {
          return;
        }
        return this.wallets.find(wallet => wallet.currency === this.currentCoin);
      },
    },
    watch: {
      user () {
        this.getDepositTransactions();
      },
    },
    methods: {
      //DEPOSIT HISTORY SECTION - BEGIN
      async getDepositTransactions () {
        if (this.user) {
          const res = await rf.getRequest('WalletRequest').getTransactions({type: 'deposit'});
          this.transactions = [...res.data];
        }
      },
      //DEPOSIT HISTORY SECTION - END
      //DEPOSIT ADDRESS SECTION - BEGIN
      selectCoin(index) {
        this.currentCoin = this.listCoin[index].name;
        this.fetchDepositAddress(this.currentCoin);
        if (this.$route.query.currency !== this.currentCoin) {
          this.$router.push({ query: { currency: this.currentCoin } });
        }
      },
      isCurrentCoin(coin) {
        return coin.name === this.currentCoin;
      },
      showQrModal() {
        if (!this.currentWallet) {
          return;
        }
        this.modalData = {
          title: this.currentWallet.currency,
          address: this.currentWallet.address,

        }
        this.$broadcast('open-modal', QrModal, this.modalData);
      },
      ...mapActions(['fetchDepositAddress']),
      //DEPOSIT ADDRESS SECTION - END
    },
    mounted() {
      const currency = this.$route.query.currency;
      const foundIndex = this.listCoin.findIndex(coin => coin.name === currency);
      if (foundIndex !== -1) {
        this.selectCoin(foundIndex);
      }
    },
    created() {
      this.$on('TransactionUpdated', () => {
        this.getDepositTransactions();
      });
      this.getDepositTransactions();
    },
  }
</script>

<style lang="scss">
  @import '../../../sass/_variables.scss';
  .deposit-question-tooltip {
    margin-top: -5px !important;
    .tooltip-arrow {
      border-color: $bg_thin_gray;
    }
    .tooltip-inner {
      color: $gray;
      text-align: left;
      min-width: 300px;
      padding: 5px 15px 4px;
      background-color: $bg_thin_gray;
      box-shadow: 0 2px 40px 0 rgba(0, 0, 0, 0.18);
    }
  }
</style>

<style scoped lang="scss">
  @import '../../../sass/_variables.scss';
  * {
    font-family: $font-family-home;
  }

  .wrapper-content {
    position: relative;

    &:after {
      background-color: #fff;
    }
  }

  .link {
    text-decoration: $link-decoration;
    color: $link-color;
    &:hover {
      text-decoration: $link-hover-decoration;
      color: $link-hover-color;
    }
  }

  .deposit-page {
    min-height: calc(100vh - 165px);
    font-size: 0;
    background: linear-gradient(90deg, #ffffff 50%, #f7f7f7 50%)
  }

  .left-content,
  .right-content {
    width: 50%;
    display: inline-block;
    vertical-align: top;
  }

  .left-content {
    padding: 52px 40px 60px 0;
  }

  .right-content {
    padding: 48px 0 60px 40px;
  }

  .right-content {
    background-color: #f7f7f7;
  }

  .title-page {
    font-size: $big;
    font-weight: bold;
    color: $black;
    display: inline-block;
    width: 30%;
    margin-bottom: 15px;
  }

  .list-coin {
    margin-bottom: 17px;
    font-size: 0;
    margin: 0 -7.5px 28px;

    .coin-item {
      position: relative;
      cursor: pointer;
      display: inline-block;
      padding: 0 7.5px;

      .coin-infor {
        background-color: #efefef;
        border-radius: 40px;
        padding: 12.5px 18px;
        .coin__image {
          width: 25px;
          margin-right: 5px;
          vertical-align: middle;
        }

        .coin__name {
          vertical-align: middle;
          font-size: $medium;
          font-weight: bold;
          text-transform: uppercase;
          color: $black;
          margin-right: 3px;
        }

        .coin__fullname {
          vertical-align: middle;
          font-size: $small;
          color: $gray;
        }
      }

      &.active .coin-infor {
        .coin__name,
        .coin__fullname {
          color: #fff;
        }
        background-color: #fa7300;
      }
    }
  }

  .balance {
    margin-bottom: 9px;
    padding: 0 52px;

    .balance__text {
      font-size: $small;
      color: #989898;
      margin-bottom: 0;
    }

    .balance__value {
      font-size: $medium;
      font-weight: bold;
      color: $gray;
    }
  }

  .content-box {
    margin-bottom: 32px;
    padding: 0 52px;

    .title {
      font-size: $small;
      color: #989898;
      margin-bottom: 0;
    }

    .address {
      font-weight: bold;
      font-size: $medium;
      text-decoration: underline;
      color: #fa7300;
      margin-bottom: 18px;
    }
  }

  .selected-coin-msg {
    margin-bottom: 15px;
    margin-top: -10px;

    .title {
      font-size: $small;
      color: #989898;
      margin-bottom: 0;
    }
  }

  .show-qr-btn,
  .copy-btn {
    cursor: pointer;
    display: inline-block;
    border-radius: 30px;
    padding: 0 24px;
    margin-right: 10px;
    border: solid 1px #da6400;
    transition: all 0.3s ease-in-out;

    .iconmo-copy,
    .iconmo-QRcode {
      vertical-align: middle;
    }

    .btn__text {
      font-size: $tiny;
      margin-left: 5px;
      vertical-align: middle;
      text-transform: uppercase;
      font-weight: bold;
      line-height: 2.5;
      letter-spacing: 0.5px;
      color: #fa7300;
    }

    &:hover {
      background-color: #fa7300;
      .iconmo-QRcode:before,
      .btn__text {
        color: #fff;
      }
    }
  }

  .copy-btn {
    padding: 0 20px 0 15px;
    background-color: #fa7300;

    .btn__text {
      color: #fff;
    }

    &:hover {
      background-color: $dark_orange;

      .btn__text,
      .iconmo-copy:before {
        color: white;
      }
    }
  }

  .text-box {
    border-radius: 10px;
    border: solid 1px #e0e0e0;
    padding: 15px 24px;

    .title {
      font-size: $small;
      font-weight: bold;
      color: #1c1c1c;
      margin-bottom: 0;
    }

    .description {
      font-size: $small;
      color: #505050;
      line-height: 1.29;
    }
  }

  .note__list {
    padding-left: 0;
    list-style: none;

    .item {
      position: relative;
      font-size: $small;
      line-height: 1.79;
      color: #505050;
      padding-left: 12px;

      &:before {
        border-radius: 50%;
        content: '';
        display: block;
        width: 3px;
        height: 3px;
        background-color: $gray;
        position: absolute;
        top: 50%;
        transform: translateY(-50%);
        left: 0;
      }
    }
  }

  .deposit-table {
    .thead {
      font-size: 0;
      border-bottom: 1px solid #b0b0b0;

      .td {
        font-size: $small;
        color: $black;
        font-weight: bold;
        display: inline-block;
        padding: 14px 0;
      }
    }

    .tbody {
      font-size: 0;

      .td {
        font-size: $small;
        display: inline-block;
        color: $gray;
        padding: 14px 0 14px 15px;
      }
    }

    .th1 {
      width: 17%;
      padding-left: 0 !important;
    }

    .th2 {
      width: 10%;
    }

    .th3 {
      width: 28%;
      padding-left: 30px !important;
    }

    .th4 {
      width: 30%;
        text-align: center;
    }

    .th5 {
      width: 15%;
      text-align: center;
      cursor: pointer;
    }
  }

  .iconmo-QRcode {
    font-size: 16px;

    &:before {
      content: "\e901";
      color: #fa7300;
    }
  }

  .iconmo-copy {
    font-size: 16px;

    &:before {
      content: "\e900";
      color: #fff;
    }
  }

  .iconmo-question:before {
    font-size: 11px;
    content: "\e902";
    color: #fa7300;
  }

  .not-found {
    margin-top: 34px;
    text-align: center;
    .not-found__icon {
      padding: 25px;
      background-color: $white;
      border-radius: 50%;
      font-size: 110px;
      display: inline-block;
      margin-bottom: 12px;
    }

    .not-found__text {
      display: block;
      font-size: 20px;
      color: $thin_gray;
    }
  }

  @media screen and (max-width: 1200px) {
    .deposit-page {
      padding: 56px 20px 80px;
      min-height: calc(100vh - 165px);
      background: none;
    }

    .left-content {
      padding: 0;
    }

    .right-content {
      padding-left: 0;
    }

    .left-content,
    .right-content {
      display: block;
      width: 100%;
    }
  }
</style>
